package ch.docuteam.packerETH.gui.launcher;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.Insets;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.border.EmptyBorder;

import ch.docuteam.converter.OOConverter;
import ch.docuteam.tools.gui.GridBagPanel;
import ch.docuteam.tools.os.OperatingSystem;
import ch.docuteam.tools.string.DateFormatter;
import ch.docuteam.tools.translations.I18N;

/**
 * Overridden because the ETH-AboutView shows an additional row.
 * @author denis
 *
 */
public class AboutView extends ch.docuteam.packer.gui.launcher.AboutView
{
	public AboutView(JFrame owner)
	{
		super(owner, I18N.translate("TitleAbout") + ch.docuteam.packerETH.admin.Version.Product);

		GridBagPanel gridBagPanel1 = new GridBagPanel(new EmptyBorder(10, 10, 10, 10), new Insets(5, 5, 5, 5));
		gridBagPanel1.add(new JLabel(new ImageIcon("./resources/images/Logo_docuteam_packer.png")),
																						0, 0, 0, 2,	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel(ch.docuteam.packerETH.admin.Version.Product),		1,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.packerETH.admin.Version.Number),		1,    1,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.packerETH.admin.Version.LastChange),	1,    2,   	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel(ch.docuteam.packer.admin.Version.Product),			2,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.packer.admin.Version.Number),			2,    1,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.packer.admin.Version.LastChange),		2,    2,   	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel(ch.docuteam.darc.admin.Version.Product),			3,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.darc.admin.Version.Number),			3,    1,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.darc.admin.Version.LastChange),		3,    2,   	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel(ch.docuteam.converter.admin.Version.Product),		4,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.converter.admin.Version.Number),		4,    1,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.converter.admin.Version.LastChange),	4,    2,   	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel(ch.docuteam.tools.admin.Version.Product),			5,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.tools.admin.Version.Number),			5,    1,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.tools.admin.Version.LastChange),		5,    2,   	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel(ch.docuteam.aipcreatorETH.admin.Version.Product),	6,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.aipcreatorETH.admin.Version.Number),	6,    1,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(ch.docuteam.aipcreatorETH.admin.Version.LastChange),6,    2,   GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel("Copyright (C) " + DateFormatter.getCurrentDateTimeString("yyyy") + " by: "),
																						7, 7, 0, 1, GridBagConstraints.WEST);
		gridBagPanel1.add(this.docuteamLink,											7,    2,    GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel("License: "),										8,    0,    GridBagConstraints.WEST);
		gridBagPanel1.add(this.licenseLink,												8, 8, 1, 2, GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel("OS: "),											9,    0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(OperatingSystem.osName() + " " + OperatingSystem.osVersion()),
																						9, 9, 1, 2,	GridBagConstraints.EAST);
		gridBagPanel1.add(new JLabel("JVM: "),											10,   0,   	GridBagConstraints.WEST);
		gridBagPanel1.add(new JLabel(System.getProperty("java.vendor") + " " + System.getProperty("java.version")),
																						10,10,1, 2,	GridBagConstraints.EAST);

		GridBagPanel gridBagPanel2 = new GridBagPanel(new EmptyBorder(10, 10, 10, 10), new Insets(5, 5, 5, 5));
		gridBagPanel2.add(new JLabel("<html><b><u>OpenOffice Installations:</u></b></html>"),
																						0, 0, 0, 3,	GridBagConstraints.CENTER);
		gridBagPanel2.add(new JLabel("Local:"),											2,    2,   	GridBagConstraints.CENTER);
		gridBagPanel2.add(new JLabel("Remote:"),										2,    3,   	GridBagConstraints.CENTER);
		gridBagPanel2.add(new JLabel("Windows:"),										3,    1,   	GridBagConstraints.EAST);
		gridBagPanel2.add(new JLabel(OOConverter.isInstalledLocallyForWindows()? "X": ""),
																						3,    2,   	GridBagConstraints.CENTER);
		gridBagPanel2.add(new JLabel(OOConverter.getRemotePathForWindows()),
																						3,    3,   	GridBagConstraints.WEST,	GridBagConstraints.HORIZONTAL,	1, 0);
		gridBagPanel2.add(new JLabel("OS X:"),											4,    1,   	GridBagConstraints.EAST);
		gridBagPanel2.add(new JLabel(OOConverter.isInstalledLocallyForOSX()? "X": ""),
																						4,    2,   	GridBagConstraints.CENTER);
		gridBagPanel2.add(new JLabel(OOConverter.getRemotePathForOSX()),	4,    3,   	GridBagConstraints.WEST,	GridBagConstraints.HORIZONTAL,	1, 0);
		gridBagPanel2.add(new JLabel("Linux:"),											5,    1,   	GridBagConstraints.EAST);
		gridBagPanel2.add(new JLabel(OOConverter.isInstalledLocallyForLinux()? "X": ""),
																						5,    2,   	GridBagConstraints.CENTER);
		gridBagPanel2.add(new JLabel(OOConverter.getRemotePathForLinux()),
																						5,    3,   	GridBagConstraints.WEST,	GridBagConstraints.HORIZONTAL,	1, 0);

		Box box = new Box(BoxLayout.Y_AXIS);
		box.add(gridBagPanel1);
		box.add(gridBagPanel2);
		this.add(box);

		this.setPreferredSize(new Dimension(450, 500));
		this.setResizable(true);
		this.pack();
		this.setLocationRelativeTo(owner);
		this.setVisible(true);
	}
}